program asterix;
const
 {$i gemconst.pas}
 noire=0;rouge=1;verte=2;jaune=3;bleue=4;rose=5;cyane=6;blanc=7;

 fh=#11 ; fb=#10 ; fd =#9 ;fg = #8 ; del = #127 ; clr = #16 ; esc = #2;

 star1 = $53544152;star2 = $5445522E;
 verif1 =$F0F1F2F3;verif2 =$F4F5F6F7;
 verif3 =$F8F9FAFB;verif4 =$FCFDFEFF;

type
 {$i gemtype.pas}
 fen = array[0..8000] of integer;
 ptrchar = ^char;
 chaine = string[12];
 str128=string[128];
 str14=string[14];
 str3=string[3];
 chemin = packed array [1..80] of char;

var
 name: string[20];
 taille:long_integer;
 handle:integer;
 coucou:chemin;
 fichier:str14;
 adresse:long_integer;
 variable: array[0..255] of integer ;
 bufsais,reponse,buflig : string[255] ;
 lettres:array[0..511] of integer;
 fond:array[0..15] of integer;

 over:array[0..3999] of integer;
 place1 : array [0..15999] of integer;
 place2 : array [0..15999] of integer;

 intro1 : array [0..16000] of integer;
 intro2 : array [0..16000] of integer;
 intro3 : array [0..16000] of integer;
 intro4 : array [0..16000] of integer;

 tabrire:array[0..4751] of integer;
 tabfoule:array[0..4848] of integer;
 tabmange:array[0..11286] of integer;
 tabbagar:array[0..4667] of integer;
 tabidefi:array[0..5769] of integer;
 tabobeli:array[0..8068] of integer;
 tabaster:array[0..8135] of integer;


 fenetre:fen;
 palette:array[0..15] of integer;
 initrez:integer;
 numfen:integer;
 ch:char;
 i,j,k:integer;
 nom1:str14;
 touche,code,note:integer;
 tableau:long_integer;
 tabadr:array[1..10] of long_integer;
 typecr,posx,posy,hauteur,c_over,c_fond,c_forme,pttab : byte;
 souli,cadre,c_deux,musicok,sortie : boolean;
 carte,max,compteur,curse : integer;
 memoire,n,kar,adr_retour,pointer,pointe:long_integer;
 lst:text;
 floppy:array[0..127] of long_integer;
 evnt,bcnt,bstate,kbd_state,key,clickx,clicky,event:integer;
 msg:message_buffer;
 drive:string[2];
 nomfich,nom  : string[20];
 fin_partie : boolean;
 endroit:integer;
 {$i gemsubs.pas}

 procedure transf(var a,b:integer);
 var x:integer;
 begin
  case initrez of
   0 : a:=a div 8;
   1 : begin
        if a>319 then a:=a-320;
        a:=a div 8;
       end;
   2 : begin a:=a div 16;b:=b div 2;end;
  end;
 end;

procedure str(a:integer;var b:str3);
begin
 b:='';
 if a>99 then b:=concat(b,chr(a div 100+48));
 if a>9 then b:=concat(b,chr((a mod 100) div 10+48));
 b:=concat(b,chr(a mod 10+48));
end;

procedure music(frequence, taille : long_integer ; var adr : integer);
external;

function fopen(var nom : chemin; mode : integer): integer;gemdos($3D);

procedure fclose(handle : integer);gemdos($3E);

function fread(handle : integer; count : long_integer;var adr : integer):
  long_integer;
 gemdos($3F);

function fseek(offset : long_integer; handle,mode : integer):
  long_integer;
 gemdos($42);

function cconin:long_integer;gemdos(7);

function dgetdrv:integer;gemdos($19);

 function find_drive:char;
 begin
  case dgetdrv of
   0 : find_drive:='a';
   1 : find_drive:='b';
   2 : find_drive:='c';
  end;
 end;


function lecsct(var fl:long_integer;z:long_integer;u,c,p,f,n:integer):boolean;
 var lec:integer;
 function floprd(var fl:long_integer;z:long_integer;u,c,p,f,n:integer):integer;
 xbios($8);
begin
 lec:=floprd(fl,z,u,c,p,f,n);
if lec=0 then lecsct:=false else lecsct:=true
end;

procedure test;
var compteur,unit:integer;
    protect:boolean;
    zero:long_integer;
begin
 compteur:=0;zero:=0;protect:=false;
 unit:=dgetdrv;
 protect:=lecsct(floppy[0],zero,unit,compteur,79,0,1);
 if (floppy[0] <> star1) or (floppy[1] <> star2) then protect:=true;
 while (compteur < 70) and (not protect) do
  begin
   protect:=lecsct(floppy[0],zero,unit,compteur,79,0,1);
   if (floppy[2] <> verif1) or (floppy[3] <> verif2) or
      (floppy[4] <> verif3) or (floppy[5] <> verif4) then protect:=true;
   compteur:=compteur+1;
  end;
 if protect then repeat until (1=2);
end;

 function init_son(a,b:integer):integer;xbios(28);

 procedure son(data,register:integer);xbios(28);

 procedure cursconf(a,b:integer);xbios($15);

 procedure set_palette(var a:integer);xbios(6);

 function physbase:long_integer;xbios(2);

 function logbase:long_integer;xbios(3);

 function getrez:integer;xbios(4);

 procedure setscreen(a,b:long_integer;c:integer);xbios(5);

 function filesize(var a:str14):long_integer;external;

 procedure sound(pitch,vol :integer);
  var s:integer;
  begin
   s:=init_son(0,7);son(s&(~7),135);
   son(vol,136);
   son(pitch&$ff,128);
   son(shr(pitch,8),129);
  end;

 procedure nosound;
 var a:integer;
  begin
   sound(0,0);
   a:=init_son(0,7);
   son(a | 7,135);
  end;

 function alea:long_integer;xbios($11);

 function random(n:integer):integer;
  begin  random:=int(alea mod n); end;

 procedure delay(a:integer);
 var i,j,k,l:integer;
 begin
  for i:= 1 to a do
   for j:=1 to 60 do k:=l;
 end;

 function litab(a:long_integer):integer;external;

 procedure ecrtab(b:byte;a:long_integer);external;

procedure openfichier;
var
 i:integer;
begin
 taille:=filesize(name);
 for i:=1 to length(name) do coucou[i]:=name[i];
 coucou[length(name)+1]:=chr(0);
 handle:=fopen(coucou,0);
end;

 function upcase(maj:char):char;
 var  asc:byte;
 begin
  if (maj>#96) and (maj<#123) then asc:=ord(maj)-32
  else asc:=ord(maj);
  upcase:=chr(asc);
 end;

 function inita (var toto : integer) : long_integer;external;

 procedure point(x,y,couleur:integer);external;

 procedure trace(x1,y1,x2,y2,couleur:integer);external;

 procedure trait(x1,y1,x2,y2,c : integer);
 var coul : integer;
 begin
  if carte=0 then
   begin
    if fond[c]=0 then coul:=3 else coul:=0;
    if typecr=80 then
     begin
      trace(x1,y1*2,x2,y2*2,coul);
      trace(x1,y1*2+1,x2,y2*2+1,coul);
     end
    else
     begin
      coul:=3;
      trace(x1*2,y1*2,x2*2,y2*2,coul);
      trace(x1*2,y1*2+1,x2*2,y2*2+1,coul);
      trace(x1*2+1,y1*2,x2*2+1,y2*2,coul);
      trace(x1*2+1,y1*2+1,x2*2+1,y2*2+1,coul);
     end;
   end
  else
   trace(x1,y1,x2,y2,c);
 end;

 procedure afi240(code,hauteur,fond,forme,x,y:integer;var a:integer);external;

 procedure afi280(code,hauteur,fond,forme,x,y:integer;var a:integer);external;

 procedure afi180(code,hauteur,fond,forme,x,y:integer;var a:integer);external;

 procedure afi040(code,hauteur,fond,forme,x,y:integer;var a:integer);external;

 procedure afiimhr(x,y,l,h:integer;im:long_integer);external;

 procedure afiimbr(x,y,l,h:integer;im:long_integer);external;

 procedure fencoul(x,y,l,h,couleur:integer);
  procedure coulfen(x,y,l,h,couleur:integer);external;
 begin
  if carte=0 then coulfen(x*16,y*2,l*16,h*2,fond[couleur])
  else coulfen(x*8,y,l*8,h,couleur);
 end;

procedure attente;
var
 carac : long_integer;
begin
 repeat
  event:=get_event(e_keyboard | e_button | e_timer,
                     1,3,0,0,
                     false,0,0,0,0,false,0,0,0,0,msg,
                     key,bcnt,bstate,clickx,clicky,kbd_state);
  event:=event & 3;
 until event=0;
 repeat
  event:=get_event(e_keyboard | e_button | e_timer,
                     1,3,0,0,
                     false,0,0,0,0,false,0,0,0,0,msg,
                     key,bcnt,bstate,clickx,clicky,kbd_state);
  event:=event & 3;
 until event<>0;
 repeat
  event:=get_event(e_keyboard | e_button | e_timer,
                     1,3,0,0,
                     false,0,0,0,0,false,0,0,0,0,msg,
                     key,bcnt,bstate,clickx,clicky,kbd_state);
  event:=event & 3;
 until event=0;
end;

 procedure crefen(x,y,l,h:integer);
 var
  i,ptrfen:integer;

  procedure window(x,y,l,h:integer;var a:integer; typc : integer);external;

 begin
  i:=0;ptrfen:=0;
  while i<numfen do
   begin ptrfen:=ptrfen+4+fenetre[ptrfen+2]*fenetre[ptrfen+3]*2;i:=i+1;end;
  if ptrfen+4+l*h*2<8000 then
   begin
    fenetre[ptrfen]:=x;fenetre[ptrfen+1]:=y;
    fenetre[ptrfen+2]:=l;fenetre[ptrfen+3]:=h;
    window(x,y,l,h,fenetre[ptrfen+4],carte);
    numfen:=numfen+1;
   end;
 end;

 procedure restore;
 var
  i,ptrfen:integer;

  procedure rest(x,y,l,h:integer;var a:integer; typc : integer);external;

 begin
  if numfen>0 then
   begin
    i:=0;ptrfen:=0;
    while i<numfen-1 do
     begin ptrfen:=ptrfen+4+fenetre[ptrfen+2]*fenetre[ptrfen+3]*2;i:=i+1;end;
    rest(fenetre[ptrfen],fenetre[ptrfen+1],fenetre[ptrfen+2],fenetre[ptrfen+3],
         fenetre[ptrfen+4],carte);
    numfen:=numfen-1;
   end;
 end;

 procedure init;
 begin
  init_mouse;hide_mouse;pttab:=0;
  tableau:=inita(place1[0]);
  initrez:=getrez;
  if initrez<>2 then
   begin
    palette[0]:=$000;palette[1]:=$003;palette[2]:=$740;palette[3]:=$624;
    palette[4]:=$700;palette[5]:=$430;palette[6]:=$077;palette[7]:=$132;
    palette[8]:=$444;palette[9]:=$555;palette[10]:=$047;palette[11]:=$040;
    palette[12]:=$772;palette[13]:=$754;palette[14]:=$664;palette[15]:=$777;
    setscreen(logbase,physbase,0);set_palette(palette[0]);carte:=1;
   end
  else
   begin
    fond[0]:=0;fond[1]:=1;fond[2]:=2;fond[3]:=3;
    fond[4]:=0;fond[5]:=1;fond[6]:=2;fond[7]:=3;
    fond[8]:=2;fond[9]:=1;fond[10]:=2;fond[11]:=2;
    fond[12]:=0;fond[13]:=1;fond[14]:=3;fond[15]:=2;
    carte:=0;
   end;
  numfen:=0;
 end;

procedure conclusion;
begin
 if initrez<>2 then setscreen(logbase,physbase,initrez);
end;

procedure action_bis;
forward;

procedure action;
forward ;

 procedure oct(car:integer; var tche,cde :integer);
  begin
   tche:=shr(car,8);cde:=car & $FF;
  end;

procedure effecr;
begin fencoul(0,0,40,200,0);end;

procedure pass80;
begin typecr:=80;effecr;end;

procedure pass40;
begin typecr:=40;effecr;end;

procedure efface(couleur : byte);
begin
 if typecr=40 then fencoul(0,0,80,200,couleur);
end;

procedure efffen( abscisse,ordonnee,larg,haut: integer);
begin
 if typecr=80 then fencoul(abscisse div 8,ordonnee,larg div 8,haut,4)
 else fencoul(abscisse div 8,ordonnee,larg div 8,haut,4);
end;

procedure aficar(ascii:byte);
var
 x1,x2,y1,y2,i,j,adr,val,val1,val2 : integer ;

begin
 if typecr=80 then
  if carte=0 then
   afi280(ascii,hauteur,c_fond,c_forme,posx,posy,lettres[0])
  else
   afi180(ascii,hauteur,c_fond,c_forme,posx,posy,lettres[0])
 else
  if carte=0 then
   begin
    while fond[c_fond]=fond[c_forme] do
     begin
      c_forme:=c_forme+1;
      if c_forme>15 then c_forme:=c_forme-15;
     end;
    afi240(ascii,hauteur,fond[c_fond],fond[c_forme],posx,posy,lettres[0]);
   end
  else
  afi040(ascii,hauteur,c_fond,c_forme,posx,posy,lettres[0]);
 if souli then
  begin
   x1:=posx*8;x2:=x1+7;y1:=posy+7+(hauteur-8) div 2;
   trait(x1,y1,x2,y1,c_forme);
  end;
 if cadre then
  begin
   x1:=posx*8-1;x2:=x1+9;y1:=posy+((hauteur-8) div 2)-1;y2:=y1+9;
   trait(x1,y1,x2,y1,c_forme);trait(x2,y1,x2,y2,c_forme);
   trait(x2,y2,x1,y2,c_forme);trait(x1,y2,x1,y1,c_forme)
  end;
 posx:=posx+1;if posx=typecr then begin posx:=0;posy:=posy+hauteur;end;
end ;

procedure afilig(posix,posiy,c_forme1,c_forme2:byte);
var
 caractere : char ;
 i         : integer ;
begin
 if c_deux then c_forme:=c_forme2 else c_forme:=c_forme1 ;
 posx:=posix;posy:=posiy;
 for i:=1 to length(buflig) do
  begin
   case buflig[i] of
    '[' :  begin c_forme:=c_forme2; c_deux:=true end ;
    ']' :  begin c_forme:=c_forme1; c_deux:=false end ;
    '{' :  souli:=true;
    '}' :  souli:=false;
   else
    :aficar(ord(buflig[i]))
   end;
  end;
end;

function lecture:integer;
var sort:boolean;
begin
 ch:=#0;
 repeat
  event:=get_event(e_keyboard | e_button,
                     1,3,0,0,
                     false,0,0,0,0,
                     false,0,0,0,0,msg,
                     key,bcnt,bstate,clickx,clicky,kbd_state);
 until event <> 0;
 oct(key,touche,code);ch:=chr(code);
 if key=$11b then ch:=esc;
 if key=$E08 then ch:=del;
 if key=$537F then ch:=clr;
 if code=$0 then
  case touche of
   $4B : ch:=fg;
   $4D : ch:=fd;
   $48 : ch:=fh;
   $50 : ch:=fb;
   else
       : if (touche>$3A) and (touche <$45) then ch:=chr(touche-37)
         else ch:=#255;
  end;
  lecture:=event
end;

procedure prelig(max : integer);
var
 long : integer;
 sort : boolean;
begin
 buflig:='';long:=0;sort:=false;
 repeat
  buflig:=concat(buflig,chr(litab(pointe)));
  long:=long+1;
  case litab(pointe) of
   123,125,91,93 : long:=long-1;
   0,64 : begin delete (buflig,length(buflig),1);sort:=true;end;
  end;
  pointe:=pointe+1;
 until (long=max) or (sort);
 if not sort then
  begin
   while litab(pointe) in [123,125,91,93] do
    begin
     buflig:=concat(buflig,chr(litab(pointe)));pointe:=pointe+1
    end;
   case litab(pointe) of
    32,64,0 : begin pointe:=pointe+1;sort:=true;end;
   end;
   if pos(' ',buflig)=0 then sort:=true;
   if not sort then
    begin
     long:=length(buflig);
     while buflig[long]<>' ' do begin long:=long-1;pointe:=pointe-1;end;
     delete(buflig,long,length(buflig)-long+1);
    end;
 end;
end;

procedure musbon;
     begin if  musicok then begin sound(240,15);delay(100);nosound;end;end;

procedure musmoyen;
     begin if  musicok then begin sound(479,15);delay(100);nosound;end;end;


procedure musmauvais;
      begin if musicok then begin sound(954,15);delay(150);nosound; end;end;

procedure musiqu(number : byte);

begin
 case number of
   0 : musbon;
   1 : musmauvais;
   2 : musmoyen;
 end;
end;

procedure afiimage(pointer : long_integer);
type
 chemin = packed array [1..80] of char;
var
 large,haute,posix,posiy,i : integer;
 numero,numfich:byte;
 coucou : chemin;

 procedure chargement0;
 var
  nbr,i,v,handle:integer;
  ptr : long_integer;
  name : string[20];

  function fopen(var nom : chemin; mode : integer): integer;gemdos($3D);
  procedure fclose(handle : integer);gemdos($3E);
  procedure afread(handle : integer; count : long_integer;var valeur: integer);
   gemdos($3F);

  procedure cherchedeb;
  begin
   repeat until fseek(ptr,handle,0)=ptr;
   afread(handle,2,v);ptr:=ptr+v;
  end;

 begin
  name:=concat(drive,nomfich,'.I00');
  for i:=1 to length(name) do coucou[i]:=name[i];
  coucou[length(name)+1]:=chr(0);
  handle:=fopen(coucou,0);
  i:=0;ptr:=0;
  while i<>numero do begin cherchedeb;i:=i+1;end;
  repeat until fseek(ptr,handle,0)=ptr;afread(handle,2,nbr);ptr:=ptr+2;
  repeat
   repeat until fseek(ptr,handle,0)=ptr;
  until fread(handle,nbr-2,place2[0])=nbr-2;
  fclose(handle);
 end;

begin
 large:=litab(pointer+5);haute:=litab(pointer+6);
 posix:=litab(pointer+3);posiy:=litab(pointer+4);
 if (litab(pointer) & 63)=1 then
  begin
   pointer:=pointer+7;
   case carte of
    0:  afiimhr(posix,posiy,large,haute,tableau+pointer);
    1 : afiimbr(posix,posiy,large,haute,tableau+pointer);
   end;
  end
 else
  begin
   numero:=litab(pointer+7);numfich:=(litab(pointer) & 63)-32;
   if numfich=0 then
    begin
     chargement0;
     case carte of
      0:  afiimhr(posix,posiy,large,haute,tableau+32000);
      1 : afiimbr(posix,posiy,large,haute,tableau+32000);
     end;
    end
   else begin end;
  end;
 adr_retour:=0;
end;

procedure afrecran(pointe : long_integer);
var
 ii,nb,oct,ll : byte;
 nombre : integer;
begin
 cadre:=false;souli:=false;
 case (litab(pointe) & 63) of
  0 : begin nombre:=24*80;ll:=80;hauteur:=8;
       if typecr<>80 then pass80 else effecr;end;
  1 : begin nombre:=24*40;ll:=40;hauteur:=8;if typecr<>40 then pass40 end;
  2 : begin nombre:=16*40;ll:=40;hauteur:=12;if typecr<>40 then pass40 end;
 end;
 if typecr=40 then effecr;
 pointe:=pointe+3;posx:=0;posy:=0;
 nb:=0;
 for ii:=1 to nombre do
  begin
   if nb=0 then
    repeat
     oct:=litab(pointe);pointe:=pointe+1;
     if oct=1 then
      begin
       c_fond:=litab(pointe) mod 16;
       c_forme:=litab(pointe) div 16;
       pointe:=pointe+1;
      end;
    until oct<>1
   else oct:=32;
   if oct=0 then begin oct:=32;nb:=litab(pointe);pointe:=pointe+1;end;
   if nb<>0 then nb:=nb-1;
   if oct>127 then begin oct:=oct-128;souli:=true;end else souli:=false;
   if (oct<>32) or (souli) or (c_fond<>4) then aficar(oct)
   else begin posx:=(posx+1) mod ll;if posx=0 then posy:=posy+hauteur;end;
  end;
 for ii:=1 to litab(pointe) do
  begin
   afiimage(pointe+1);pointe:=pointe+litab(pointe+2)*256+litab(pointe+3);
  end;
 adr_retour:=0;
end;

procedure afiecran(pointe : long_integer);
var memo : byte;
begin
 memo:=typecr;afrecran(pointe);
 attente;
 if memo<>typecr then
  if memo=40 then pass40 else pass80
 else effecr;
end;

procedure clique;
var
 rep,i : byte;
 f:boolean;
 a_esc,nbrpos : integer;
begin
 repeat
  repeat
   adresse:=tabadr[pttab];
   nbrpos:=litab(adresse+3);
   a_esc:=litab(adresse+1)*256+litab(adresse+2);
   f:=false;show_mouse;
   repeat
    repeat until lecture <>0;
    if event=1 then begin if ch=esc then f:=true;end;
    if event=2 then f:=true;
   until f;
   hide_mouse;
   f:=false;
   if ch=esc then f:=true
   else
    begin
     transf(clickx,clicky);
     pointe:=adresse+4;rep:=0;
     for i:=1 to nbrpos do
      begin
       if (clickx>=litab(pointe)) and (clickx<litab(pointe)+
        litab(pointe+2))and (clicky>=litab(pointe+1))
        and (clicky<litab(pointe+1)+litab(pointe+3)) then rep:=i;
       pointe:=pointe+4;
      end;
     pointe:=adresse+4+4*nbrpos+rep*3;
     if litab(pointe)=1 then
      begin adr_retour:=litab(pointe+1)*256+litab(pointe+2);f:=true;end
     else
      begin
       pttab:=pttab+1;
       tabadr[pttab]:=litab(pointe+1)*256+litab(pointe+2);action;f:=false;
      end;
    end;
  until f;
  if ch=esc then
   begin
    pttab:=pttab+1;
    tabadr[pttab]:=a_esc;action;f:=false;
   end;
 until f;
end;

procedure sous_groupe(var ptr : long_integer);
begin
 case litab(ptr+1) of
  1 : begin
       crefen(litab(ptr+2),litab(ptr+3),litab(ptr+4),litab(ptr+5));
       ptr:=ptr+6;
      end;
  2 : begin restore;ptr:=ptr+2;end;
  3 : begin
       if litab(ptr+2)=0 then attente
       else delay(litab(ptr+2)*5);
       ptr:=ptr+3;
      end;
  4 : begin efface(litab(ptr+2));ptr:=ptr+3;end;
  5 : begin
       variable[litab(ptr+2)*2]:=litab(ptr+3);
       variable[litab(ptr+2)*2+1]:=litab(ptr+3);
       ptr:=ptr+4;
      end;
  6 : begin
       variable[litab(ptr+2)*2]:=variable[litab(ptr+3)*2];
       variable[litab(ptr+2)*2+1]:=variable[litab(ptr+3)*2];
       ptr:=ptr+4;
      end;
  7 : begin
       if variable[litab(ptr+2)*2]+litab(ptr+3)<litab(ptr+3) then
        begin
         variable[litab(ptr+2)*2]:=255;
         variable[litab(ptr+2)*2+1]:=255;
        end
       else
        begin
         variable[litab(ptr+2)*2]:=
          variable[litab(ptr+2)*2]+litab(ptr+3);
         variable[litab(ptr+2)*2+1]:=
          variable[litab(ptr+2)*2+1]+litab(ptr+3);
        end;
       ptr:=ptr+4;
      end;
  8 : begin
       if variable[litab(ptr+2)*2]+variable[litab(ptr+3)*2] <
        litab(ptr+3) then
        begin
         variable[litab(ptr+2)*2]:=255;
         variable[litab(ptr+2)*2+1]:=255;
        end
       else
        begin
         variable[litab(ptr+2)*2]:=
          variable[litab(ptr+2)*2]+variable[litab(ptr+3)*2];
         variable[litab(ptr+2)*2+1]:=
          variable[litab(ptr+2)*2+1]+variable[litab(ptr+3)*2];
        end;
       ptr:=ptr+4;
      end;
  9 : begin
       if variable[litab(ptr+2)*2]<litab(ptr+3) then
        begin
         variable[litab(ptr+2)*2]:=0;
         variable[litab(ptr+2)*2+1]:=0;
        end
       else
        begin
         variable[litab(ptr+2)*2]:=
          variable[litab(ptr+2)*2]-litab(ptr+3);
         variable[litab(ptr+2)*2+1]:=
          variable[litab(ptr+2)*2+1]-litab(ptr+3);
        end;
       ptr:=ptr+4;
      end;
 10 : begin
       if variable[litab(ptr+2)*2]< variable[litab(ptr+3)*2] then
        begin
         variable[litab(ptr+2)*2]:=0;
         variable[litab(ptr+2)*2+1]:=0;
        end
       else
        begin
         variable[litab(ptr+2)*2]:=
          variable[litab(ptr+2)*2]-variable[litab(ptr+3)*2];
         variable[litab(ptr+2)*2+1]:=
          variable[litab(ptr+2)*2+1]-variable[litab(ptr+3)*2];
        end;
       ptr:=ptr+4;
      end;
 11 : begin
       case litab(ptr+2) of
        0,1 : begin
               music(2,113077,intro1[0]);
               music(2,113077,intro1[0]);
              end;
          2 : music(1,9501,tabrire[0]);
          3 : music(1,9696,tabfoule[0]);
          4 : music(3,22572,tabmange[0]);
          5 : music(1,9224,tabbagar[0]);
          6 : music(3,11538,tabidefi[0]);
          7 : music(3,16136,tabobeli[0]);
          8 : music(4,16136,tabobeli[0]);
          9 : music(3,16269,tabaster[0]);
         10 : music(2,16269,tabaster[0]);
         11 : music(4,16269,tabaster[0]);
       end;
       ptr:=ptr+3;
      end;
 end;
end;


procedure groupe;
var
 i,nb : array [1..10] of integer ;
 ptr : array [1..10] of long_integer;
begin
 ptr[pttab]:=tabadr[pttab];nb[pttab]:=litab(ptr[pttab]+1);
 ptr[pttab]:=ptr[pttab]+2;
 if nb[pttab]>0 then
  begin
   i[pttab]:=1;
   while i[pttab]<nb[pttab] do
    begin
     if litab(ptr[pttab])<>255 then
      begin
       pttab:=pttab+1;
       tabadr[pttab]:=litab(ptr[pttab-1])*256+litab(ptr[pttab-1]+1);action;
       ptr[pttab]:=ptr[pttab]+2;
      end
     else sous_groupe(ptr[pttab]);
     i[pttab]:=i[pttab]+1;
    end;
   if litab(ptr[pttab])<>255 then
    adr_retour:=litab(ptr[pttab])*256+litab(ptr[pttab]+1)
   else begin sous_groupe(ptr[pttab]);adr_retour:=0;end;
  end
 else adr_retour:=0;
end;

procedure bulle(adresse : long_integer);
var
 c1,c2,l,x,y,hmax,fleche,
 x1,y1,l1,h1,x2,y2,l2,h2 : byte;
 numlig:integer;
begin
 pointe:=adresse+1;c_deux:=false;
 fencoul(litab(pointe),litab(pointe+1),litab(pointe+2),litab(pointe+3),
  litab(pointe+5));
 hauteur:=litab(pointe+4);c_fond:=litab(pointe+5);
 hmax:=litab(pointe+1)+litab(pointe+3);
 x:=litab(pointe);y:=litab(pointe+1);l:=litab(pointe+2);
 c1:=litab(pointe+6);c2:=litab(pointe+7);pointe:=pointe+9;
 cadre:=false;souli:=false;c_deux:=false;
 x1:=x+l-3;y1:=y;l1:=3;h1:=(hmax-y) div 2;
 x2:=x1;y2:=y+(hmax-y) div 2;l2:=3;h2:=h1;
 pointe:=adresse+10;y:=litab(adresse+2);
 repeat
  prelig(l);afilig(x,y,c1,c2);
  y:=y+hauteur;
 until (litab(pointe-1)=0);
 adr_retour:=0;
end;

procedure hasard(adres : long_integer);
var i : long_integer;
begin
 i:=adres+2+2*random(litab(adres+1));
 adr_retour:=litab(i)*256+litab(i+1);
end;

procedure teste(adres : long_integer);
var
 i : long_integer;
 sort:boolean;
begin
 repeat
  i:=adres+4;
  case litab(adres+1) of
   0 : if variable[litab(adres+2)*2]<litab(adres+3) then i:=i+3;
   1 : if variable[litab(adres+2)*2]=litab(adres+3) then i:=i+3;
   2 : if variable[litab(adres+2)*2]<variable[litab(adres+3)*2] then i:=i+3;
   3 : if variable[litab(adres+2)*2]=variable[litab(adres+3)*2] then i:=i+3;
  end;
  if litab(i)=1 then
   begin adr_retour:=litab(i+1)*256+litab(i+2);sort:=true;end
  else
   begin
    pttab:=pttab+1;tabadr[pttab]:=litab(i+1)*256+litab(i+2);
    action;sort:=false;
   end;
 until sort;
end;

procedure qcmsimple;
var
 change,fin : boolean;
 rep,j : byte;
 point : array[1..10,1..10] of byte;
begin
 change:=true;
 repeat
  repeat
   adresse:=tabadr[pttab];
   if adresse<0 then adresse:=65536+adresse;
   if change then
    begin
     pttab:=pttab+1;tabadr[pttab]:=litab(adresse+3)*256+litab(adresse+4);
     action_bis;adresse:=tabadr[pttab];
     if adresse<0 then adresse:=65536+adresse;pointe:=adresse+7;
     for j:=1 to litab(adresse+6) do
      begin
       point[j,pttab]:=litab(pointe);
       pointe:=pointe+4;
      end;
    end;
   change:=false;
   repeat
    repeat until lecture=1;
   until (ch=esc) or (  ( ord(ch)>48 ) and ( ord(ch)<49+litab(adresse+6) )  );
   if (ch<>esc) then
    begin
     rep:=ord(ch)-48;
     case point[rep,pttab] of
      0 : musmauvais;
      1 : musmoyen;
      2 : musbon;
     end;
     variable[litab(adresse+3)*2]:=
                   variable[litab(adresse+3)*2]+point[rep,pttab];
     variable[litab(adresse+3)*2+1]:=variable[litab(adresse+3)*2+1]+2;
     pointe:=adresse+7+4*(rep-1)+1;
     change:=(litab(pointe+1)*256+litab(pointe+2)<>0);fin:=false;
     if litab(pointe)=1 then
      begin adr_retour:=litab(pointe+1)*256+litab(pointe+2);fin:=true;end
     else
      begin
       pttab:=pttab+1;
       tabadr[pttab]:=litab(pointe+1)*256+litab(pointe+2);action;
       fin:=false;adresse:=tabadr[pttab];
      end;
    end;
  until (ch=esc) or fin;
  if ch=esc then
   begin
    pttab:=pttab+1;
    tabadr[pttab]:=litab(adresse+1)*256+litab(adresse+2);action;
    change:=(litab(adresse+1)*256+litab(adresse+2)<>0);fin:=false;
   end;
 until fin;
end;

procedure action_commun;
var
 sort:boolean;
begin
 adresse:=tabadr[pttab];
 if adresse<0 then adresse:=65536+adresse;
 sort:=false;adr_retour:=adresse;
 repeat
  adresse:=adr_retour;
  if litab(adresse)>127 then
   begin afiecran(adresse);sort:=true;end;
  if (litab(adresse)>63) and (not sort)
   then begin afiimage(adresse);sort:=true;end;
  if not sort then
   begin
    case litab(adresse) of
     27    : clique;
     28    : groupe;
     29    : bulle(adresse);
     32    : hasard(adresse);
     33    : teste(adresse);
     34    : qcmsimple;
     else  : adr_retour:=0;
    end;
    tabadr[pttab]:=adr_retour;sort:=false;
   end;
 until (adr_retour=0) or sort;
end;

procedure action_bis;
begin
 adresse:=tabadr[pttab];
 if adresse<>0 then
  begin
   if adresse<0 then adresse:=65536+adresse;
   if litab(adresse)>127 then afrecran(adresse)
   else action_commun;
  end;
  pttab:=pttab-1;
end;

procedure action;
begin
 adresse:=tabadr[pttab];
 if adresse<>0 then action_commun;
 pttab:=pttab-1;
end;

procedure executeur;
var
 i : integer ;
 ptr : long_integer;
begin
 name:=concat(drive,nomfich,'.tot');openfichier;
 repeat
   repeat until fseek(0,handle,0)=0;
 until fread(handle,taille,place1[0])=taille;
 fclose(handle);
 name:=concat(drive,'intro.spl');openfichier;
 repeat
   repeat until fseek(0,handle,0)=0;
 until fread(handle,taille,intro1[0])=taille;
 fclose(handle);
 numfen:=0;pttab:=0;
 if litab(2)*256+litab(3)<>0 then
  begin
   ptr:=litab(2)*256+litab(3);
   for i:=1 to litab(ptr) do
    if litab(ptr+1)<>255 then
     begin
      pttab:=pttab+1;tabadr[pttab]:=litab(ptr+1)*256+litab(ptr+2);
      action;ptr:=ptr+2;
     end
    else begin ptr:=ptr+1;sous_groupe(ptr);ptr:=ptr-1;end;
  end;
end;

procedure initcharge;
var
 fichier:file of integer;
 i : integer;
begin
 c_fond:=4;cursconf(0,0);drive:=concat(find_drive,':');
 reset(fichier,'lettres.bin');
 for i:=0 to 511 do begin lettres[i]:=fichier^;get(fichier);end;close(fichier);
 musicok:=true;pass40;effecr;
end;

begin
 if init_gem>=0 then
  begin
   init;initcharge;
   for i:=0 to 255 do variable[i]:=0 ;
   nomfich:='test';executeur;
   conclusion;
   show_mouse;exit_gem;
  end;
end.


